
 NOlist
 include "..\..\ti83plus.inc"
 globals on
;This is the application header definition area required for all apps.
 ;Field: Program length
	DB 080h,0Fh
;Length=0 (N/A for unsigned apps)
	DB 00h,00h,00h,00h 
;Field: Program type
	DB 080h,012h
	DB 01h,04h
;Field: App ID
	DB 080h,021h
;Id = 1
	DB 01h
;Field: App Build
	DB 080h,031h
	;Build = 1
	DB 01h
;Field: App Name
	DB 080h,048h
;App Name = APPNAME
	DB "MolWght "
;Field: App Pages
	DB 080h,081h
;App Pages = 1
	DB 01h
;No default splash screen
	DB 080h,090h
;Field: Date stamp - 5/12/1999
	DB 003h,026h,009h,004h,004h,06fh,01bh,080h
;Dummy encrypted TI date stamp signature
	DB 002h ,00dh ,040h                             
	DB 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
	DB 0f5h ,085h ,09ch ,009h ,06ch ,00fh ,0b4h ,003h ,09bh ,0c9h 
	DB 003h ,032h ,02ch ,0e0h ,003h ,020h ,0e3h ,02ch ,0f4h ,02dh 
	DB 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
	DB 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
	DB 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
	DB 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
;Field: Program Image length
	DB 80h,7Fh
	DB 0,0,0,0    ;Length=0, N/A
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0	;Reserved
 list

	define debug
VPutMap macro   pencol,char
	call VPutMapMacro
	DB	pencol
	DB char
	ifdef debug
	nop
	endif
	.endm

elementloc		equ	tempswaparea ;pointer
totaalatoms		equ	tempswaparea+2 ;2 bytes
totaalsoorten	equ	tempswaparea+4 ;1 byte
topline			equ	tempswaparea+5 ;1 byte
tempname			equ	tempswaparea+6 ;4 bytes
input				equ	tempswaparea+10 ;44 bytes and ops after it
totaalfloat		equ	tempswaparea+54 ;9 bytes
totatomsfloat	equ	tempswaparea+63 ;9bytes
molesfloat:	equ	tempswaparea+72 ;9bytes
massfloat		equ	tempswaparea+81 ;9bytes
moleculesfloat	equ	tempswaparea+90 ;9bytes
atomsfloat		equ	tempswaparea+99 ;9bytes

endofatomtable	equ	tempswaparea+128 ;2 bytes
atomtable		equ	tempswaparea+130 ;192 (2*96) bytes

screenloc	equ	appbackupscreen

displaybrackets	equ 0 ;flag in asm_Flag1 

start:
	set fullScrnDraw, (IY + apiFlg4)
	res plotLoc, (IY + plotFlags)
	res bufferOnly, (IY + plotFlag3)
	set textWrite, ( 	IY + sGrFlags)
	res continue, (IY+ asm_Flag1)
start_getinput:
	set moleculeinput,(IY+asm_Flag1) 
	call getinput
	ld hl,screenloc
	ld bc,768
	B_CALL MemClear
	ld hl,tempswaparea
	ld bc,323
	B_CALL MemClear
	ld a,80h
	ld (totaalfloat+1),a
	ld hl,atomtable
	ld (endofatomtable),hl
	call LookupEntry
	jr c,$f
	inc de
	inc de
	ex de,hl
	ld a,(hl)
	or a
	jr nz,loop
$$:
	ld hl,teststr
loop:
	ld a,(hl)
	or a
	jr z,loop2_start ;finished loop
	call getonelement
	jr loop
loop2_start:
	ld hl,(endofatomtable)
	ld bc,atomtable
	or a
	sbc hl,bc
	ld a,l
	sra a
	cp 46
	jr nc,err_toomanyatoms ;too many atoms
	ld (totaalsoorten),a
	ld b,a
	ld hl,atomtable
	ld de,screenloc
loop2:
	push bc
	push hl
	call LdHLInd
	ex de,hl
	ld (elementloc),hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ex de,hl
	call processelement
	pop hl
	pop bc
	inc hl
	inc hl
	djnz loop2
	call DeleteEntry
displayscreen:
	B_CALL GrBufClr
	ld hl,0*256+1
	ld (pencol),hl
	ld a,(topline)
	push af
	ld b,0
	ld c,a
	ld h,0
	ld l,a
	or a
	jr z,displayscreen_noscrollup
	ld a,SupArrow
	B_CALL VPutMap
displayscreen_noscrollup:
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,screenloc
	add hl,bc
	ld a,(totaalsoorten)
	push af
	cp 6+1
	jr c,displayscreen_noscroll
	ld a,6
displayscreen_noscroll:
	ld b,a
displayscreen_loop:
	push bc
	call displayline
	pop bc
	djnz displayscreen_loop
	ld h,1
	ld bc,4*256+13
	ld de,91*256+13
	B_CALL ILine
	pop bc ;total nr of different atoms
	pop af ;topline
	add 6
	cp b
	jr nc,displayscreen_noscrolldown
	ld hl,49*256+1
	ld (pencol),hl
	ld a,SdownArrow
	B_CALL VPutMap
displayscreen_noscrolldown:
	ld hl,52*256+7
	ld (pencol),hl
	ld hl,atomsstr
	call VPutS
	ld hl,(totaalatoms)
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
	ld de,totatomsfloat
	call MovFrOP1
	ld a,6
	call VDisplayOP1
	ld a,54
	ld (pencol),a
	ld hl,totaalfloat
	rst 20h
	ld a,10
	call VDisplayOP1
	B_CALL GrBufCpy
keyloop:
	B_CALL GetKey
	ld hl,topline
	cp kUp
	jr z,up
	cp kDown
	jr z,down
	jr unknownmenu

weightstr:
	db "Weight:",0
atomsstr:
	db "Atoms:",0
molesstr:
	db "Moles:",0

weightandatominput:
	res moleculeinput,(IY+asm_flag1)
	set reqposint,(IY+asm_flag1)
	res continue, (IY+ asm_Flag1)
	ld hl,atomsstr
	call getinput
	ld de,totatomsfloat
	call MovFrOP1
	res reqposint,(IY+asm_flag1)
	ld hl,weightstr
	call getinput
	ld de,totaalfloat
	call MovFrOP1

unknownmenu:
	res moleculeinput,(IY+asm_flag1)
	res reqposint,(IY+asm_flag1)
	set emptyedits,(IY+asm_flag1)
	res continue, (IY+ asm_Flag1)
	call getinput
	jr quit
	res moleculeinput,(IY+asm_flag1)
	res reqposint,(IY+asm_flag1)
moles:
	ld hl,molesstr
	call getinput
	ld de,molesfloat
	call MovFrOP1
	;
	ld hl,avogradoconst
	call MovToOP2
	B_CALL FPMult
	ld de,moleculesfloat
	call MovFrOP1
	;
	ld hl,molesfloat
	rst 20h
	ld hl,totaalfloat
	call MovToOP2
	B_CALL FPMult
	ld de,massfloat
	call MovFrOP1
	;
	ld hl,moleculesfloat
	rst 20h
	ld hl,totatomsfloat
	call MovToOP2
	B_CALL FPMult
	ld de,atomsfloat
	call MovFrOP1
	;
dispdata:
	B_CALL GrBufClr
	ld hl,1*256+1
	ld (pencol),hl
	ld hl,moleculesfloat
	call VDisplayHL_indirect
	B_CALL GrBufCpy
	B_CALL GetKey

quit:
	res textWrite, (IY + sGrFlags)
	res fullScrnDraw, (IY + apiFlg4)
	res plotLoc, (IY + plotFlags)
	B_JUMP JForceCmdNoChar

avogradoconst:
	db 0,80h+23,60h,22h,14h,0,0,0,0

up:
	ld a,(hl)
	or a
	jr z,keyloop
	dec (hl)
	jr displayscreen
down:
	ld a,(hl)
	dec hl
	ld b,(hl) ;total nr of different atoms
	add 6
	cp b
	jr nc,keyloop
	inc hl
	inc (hl)
	jr displayscreen

displayline:
	ld a,(penrow)
	add 7
	ld b,a
	ld c,1
	ld (pencol),bc
	ld b,(hl)
	call VPutSelementstr
	VPutMap 13,":"
	inc hl
	ld a,(hl)
	push hl
	call VDisplayA
	pop hl
	VPutMap 27,"*"
	inc hl
	ld a,(hl)
	res displaybrackets,(IY+asm_Flag1)
	or a
	jr z,nobrackets
	ld a,"("
	B_CALL VPutMap
	set displaybrackets,(IY+asm_Flag1)
nobrackets:
	inc hl
	call VPutS7
	bit displaybrackets,(IY+asm_Flag1)
	jr z,nobrackets2
	ld a,")"
	B_CALL VPutMap
nobrackets2:
	VPutMap 65,"="
	call VPutS7
	push hl
	pop hl
	ret

_GoToErrOffset equ 4CD8h

err_overflow:
	ld hl,err_overflow_str
	jr err_calculateoffset
err_unknownatom:
	ld hl,err_unknownatom_str
	jr err_calculateoffset
err_invalidinput:
	ld hl,err_invalidinput_str
err_calculateoffset:
	push hl
	ld hl,(errOffset)
	ld de,(editTop)
	or a
	sbc hl,de
	ld (errOffset),hl
err_continue:
	ld hl,0
	ld (currow),hl
	ld hl,err_str
	call PutS
	B_CALL EraseEOL
	pop hl
	call PutS
	B_CALL GetKey
	set continue, (IY+ asm_Flag1)
	jr start_getinput

err_unknownweightforatom:
	ld hl,err_unknownweightforatom_str
	jr err_nooffset
err_toomanyatoms:
	ld hl,err_toomanyatoms_str
err_nooffset:
	push hl
	ld hl,0
	ld (errOffset),hl
	jr err_continue
err_str:
	db "ERR:",0
err_unknownatom_str:
	db "UNKNOWN ATOM",0
err_invalidinput_str:
	db "INVALID",0
err_unknownweightforatom_str:
	db "UNKNOWN WGHT",0
err_overflow_str:
err_toomanyatoms_str:
	db "NR OF ATOMS",0

VPutSelementstr:
	push hl
	ld hl,names
	dec b
	jr z,findelementstr_namesearch_found
	xor a
findelementstr_namesearch:
	ld c,0FFh
	cpir
	djnz findelementstr_namesearch
findelementstr_namesearch_found:
	call VPutS
	pop hl
	ret

processelement:
	push hl
	ld b,l
	ld hl,weights
	dec b
	jr z,processelement_opsearch_found
	ld a,0FFh
processelement_opsearch:
	ld c,0FFh
	cpir
	djnz processelement_opsearch
processelement_opsearch_found:
	;hl contains pointer to op value
	ld a,(hl)
	inc a
	jr z,err_unknownweightforatom ;unknown
	dec a ;check 0
	jr nz,processelement_opsearch_nobrackets
	ld c,2
	call getelementlocplusc
	ld a,1
	ld (de),a
	inc de
	inc hl ;display brackets
processelement_opsearch_nobrackets:
	push hl
	B_CALL ZeroOP1
	pop hl
	ld de,OP1+1
processelement_opcopyloop:
	ldi
	ld a,(hl)
	inc a
	jr nz,processelement_opcopyloop
	ld c,3
	call convop1tostr
	pop hl
	ld l,h
	ld h,0
	push hl
	ld bc,(totaalatoms)
	add hl,bc
	ld (totaalatoms),hl
	pop hl
	B_CALL SetXXXXOP2
	B_CALL FPMult
	ld c,3+7
	call convop1tostr
	ld hl,totaalfloat
	push hl
	B_CALL Mov9ToOP2
	B_CALL FPAdd
	pop de
	call MovFrOP1
	ld c,3+7+7
	call getelementlocplusc
	ret

getelementlocplusc:
	ex de,hl
	ld b,0
	ld hl,(elementloc)
	add hl,bc
	ex de,hl
	ret

getonelement:
	ld (errOffset),hl;for error handling
	ld a,(hl)
	call checkuppercase
	pop bc
	jr c,err_invalidinput
	push bc
	ld de,tempname
	add 35
getonelement_nameloop:
	sub 35
	ld (de),a
	inc hl
	inc de
	push hl
	ld hl,tempname+4
	or a
	sbc hl,de
	pop hl
	jr z,err_unknownatom ;4 or more characters long
	ld a,(hl)
	or a
	jr z,getonelement_zeroterminator
	ld b,0
	call checknumberanduppercase
	jr c,getonelement_nameloop
getonelement_zeroterminator:
	push af
	xor a
	ld (de),a
	push hl
	ld hl,names
	ld b,0
getonelement_bigatomnrloop:
	inc b
	ld de,tempname
	jr getonelement_smallatomnrloop_start
getonelement_smallatomnrloop:
	or a
	jr z,getonelement_found
	inc hl
	inc de
getonelement_smallatomnrloop_start:
	ld a,(de)
	cp (hl)
	jr z,getonelement_smallatomnrloop
	push bc
	ld bc,0FFFFh
	xor a
	cpir
	pop bc
	ex de,hl
	ld hl,names_end
	or a
	sbc hl,de
	ex de,hl
	jr z,err_unknownatom ;notfound
	jr nz,getonelement_bigatomnrloop
getonelement_found: ;b contains element nr
	pop hl
	pop af
	push bc
	ld b,0
	call checknumber
	jr nc,getonelement_loop2_start
	ld a,1
	jr getonelement_loop2_end
getonelement_loop2:
	sub L0
	ld c,a
	ld a,b
	cp 26
	jr nc,err_overflow ;overflow
	add a
	ld b,a
	add a
	add a
	add b 
	add c ;a=10*b+a
	jr c,err_overflow ;overflow
	ld b,a
	inc hl
getonelement_loop2_start:
	ld a,(hl)
	call checknumber
	jr nc,getonelement_loop2
	ld a,b
getonelement_loop2_end:
	;a = coefficient
	pop bc
	ld c,a
	push hl
	;
	ld hl,atomtable
atomtableloop:
	ld de,(endofatomtable)
	ex de,hl
	or a
	sbc hl,de
	ex de,hl
	jr z,atomtable_endreached
	ld a,(hl)
	inc hl
	cp b
	jr z,atomtable_found
	inc hl
	jr atomtableloop
atomtable_endreached:
	inc hl
	inc hl
	ld (endofatomtable),hl
	dec hl
	dec hl
	ld (hl),b
	inc hl
atomtable_found:
	ld a,(hl)
	add c
	jr c,err_overflow
	ld (hl),a
	;
	pop hl
	ret



checknumberanduppercase:
	cp L0
	ret c
	cp L9+1
	ccf
	ret nc
checkuppercase:
	cp "A"
	ret c
	cp "Z"+1
	ccf
	ret nc
	scf
	ret

checknumber:
	cp L0
	ret c
	cp L9+1
	ccf
	ret nc
	scf
	ret

names:
 include "names.asm"
names_end:
weights:
 include "weights.asm"
 include "helper functions.asm"
 include "sysinput.asm"

;teststr2:
;	db "Uuo",L2,L5,L0,"H","He",L1,L0,"Au",L9,"OHC","KrKrKrKrKr",L4
;	db "Uuo",L4,"H","He",L1,L0,"Au",L9,"OHC",0
;endofapp2:

teststr:
	db "U","u"+35,"o"+35,L2,L5,L0,"H","H","e"+35,L1,L0,"A","u"+35,L9,"OHC","K","r"+35,"K","r"+35,"K","r"+35,"K","r"+35,"K","r"+35,L4
	db "U","u"+35,"o"+35,L4,"H","H","e"+35,L1,L0,"A","u"+35,L9,"OHC",0
endofapp:
